module i2s_recv (datain, lrclk, bclk, clk, dataout, latchout, lrdelayed, bitcount);

input	 	datain;
input		lrclk;
input		bclk;
input		clk;

output signed [23:0]		dataout;

reg			[23:0]		data_reg;
wire		[23:0]		dataout;

output reg	latchout;

reg			[3:0]		state;

output reg	[5:0]	bitcount;

output reg	lrdelayed;

assign dataout = data_reg;

always @(posedge bclk)
	begin
      case (state)
        0 : if (!lrclk) begin		// Wait until lrclk goes low
			data_reg <= 0;			// Clear word buffer
			bitcount <= 0;			// Clear bitcount
			state <= 1;				// Go to state 1 on next bclk (ignore first blck)
            end

        1 : begin
			lrdelayed <= 0;
			data_reg = {data_reg[22:0], datain};	// Start clocking in bits (add new bit as LSB)...
			bitcount = bitcount + 1;
			
			if (lrclk) begin						// ...When lrclk goes high
			lrdelayed <= 1;
			latchout <= 1;						// Start latchout process
			state <= 2;								// ...Go to state 2
			end
		end
		
        2 : begin									// One blck tick AFTER lrclk = high
			latchout <= 0;
			state <= 0;
		end
		
	endcase
end

	initial begin
	state <= 0;
	latchout <=0;
	end
	
endmodule