module outputblock (
	datain,
	latchen,
	lrclk,
	bclk,
	i2s_dataout,
	bitcount,
	storage);
	
	input [47:0] datain;
	input latchen;
	input bclk;
	input lrclk;
	
	reg [1:0] state;
	
	output reg [23:0] storage;
	output	i2s_dataout;

	output reg	[5:0] bitcount;
	
	assign i2s_dataout = storage[23];

always @(posedge bclk or posedge latchen)
		if (latchen) storage[23:0] <= datain[47:0];
		else begin

      case (state)					// Whole "case" section is clocked by bclk
        0 : if (!lrclk) begin		// Wait until lrclk goes low
			bitcount <= 1;			// Start bitcount at 1
			state <= 1;
			end
			
		1 : begin
			storage <= storage << 1;
			bitcount = bitcount + 1;

			if (lrclk) begin		// Keep clocking out bits until lrclk goes high
			state <= 2;				// Go to state 2
			end
		end
			
		2 : begin
			state <= 0;				// Go to state 0
			end

endcase

end

endmodule